"use strict";

exports.__esModule = true;
exports.default = createD3NumberFormatter;

var _d3Format = require("d3-format");

var _core = require("@superset-ui/core");

var _NumberFormatter = _interopRequireDefault(require("../NumberFormatter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createD3NumberFormatter(config) {
  const {
    description,
    formatString = (0, _core.isRequired)('config.formatString'),
    label,
    locale
  } = config;
  let formatFunc;
  let isInvalid = false;

  try {
    formatFunc = typeof locale === 'undefined' ? (0, _d3Format.format)(formatString) : (0, _d3Format.formatLocale)(locale).format(formatString);
  } catch (error) {
    formatFunc = value => value + " (Invalid format: " + formatString + ")";

    isInvalid = true;
  }

  return new _NumberFormatter.default({
    description,
    formatFunc,
    id: formatString,
    isInvalid,
    label
  });
}